/***************************************************************************
 *   Copyright (C) 2009 by Ben Wolf   *
 *   bswolf@cs.cmu.edu   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _ENEMY_H
#define _ENEMY_H

#include "graphics.h"
#include "Ship.h"
#include "Laser.h"
#include <list>
#include "calc.h"

using namespace std;

class Enemy : public Ship {
protected:
	int count;
	list<point> path;
	int vel;
	int rate;
	point shift(point a);

public:
	/** @brief Creates an enemy that moves and fires at specified rates. */
	Enemy(int x, int y, int dir, list<point> path, int vel,
			int rate, int offset,
			SDL_Surface* image, void (*laser_callback)(Laser));

	virtual void move();
};

#define FSHOOTER_RATE 100
#define FSHOOTER_OFFSET 40
#define FSHOOTER_VEL 3

class FShooter : public Enemy {
private:
	point u1;
	point u2;
	point u3;

public:
	FShooter(int x, int y, int dir, list<point> path, int vel,
			int rate, int offset, void (*laser_callback)(Laser));

	virtual bool doesCollide(int x, int y);
	virtual void fireLaser();
};

#define DSHOOTER_RATE 100
#define DSHOOTER_OFFSET 50
#define DSHOOTER_VEL 3

class DShooter : public Enemy {
private:
	point u1;
	point u2;
	point u3;
	point u4;
	point u5;
	point u6;

public:
	DShooter(int x, int y, int dir, list<point> path, int vel,
			int rate, int offset, void (*laser_callback)(Laser));

	virtual bool doesCollide(int x, int y);
	virtual void fireLaser();
};

#endif /* _ENEMY_H */
