/***************************************************************************
 *   Copyright (C) 2009 by Ben Wolf   *
 *   bswolf@cs.cmu.edu   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _PLAYER_H
#define _PLAYER_H

#include "Ship.h"
#include "Laser.h"
#include <list>
using namespace std;

#define PLAYER_VEL 3

typedef struct bound {
	int bounds_n;
	int bounds_e;
	int bounds_s;
	int bounds_w;
} bound;

class Player : public Ship {
protected:
	int maxshots;
	list<bound> bounds;
	bool inbounds(bound b, int px, int py);

#define MAX_SHOTS 5

public:
	/** @brief Create a player ship at the specified point,
	 *         with the specified bounding box.
	 */
	Player (int x, int y, int shots, int image,
		void (*laser_callback)(Laser));

	void clearBounds();
	void addBounds(int bounds_x1, int bounds_y1, int bounds_x2, int bounds_y2);
	void setPos(int x, int y);

	int getMaxShots();

	virtual bool doesCollide(int x, int y);
	virtual void fireLaser();
	virtual void move();
	virtual void hit();
	virtual void draw();
};

#endif /* _PLAYER_H */
