/***************************************************************************
 *   Copyright (C) 2009 by Ben Wolf   *
 *   bswolf@cs.cmu.edu   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _WALL_H
#define _WALL_H

#include "direction.h"
#include "graphics.h"
#include "Sprite.h"

#define THICKNESS 6

class Wall : public Sprite {
private:
	int direction;
	int x1;
	int y1;
	int x2;
	int y2;

public:
	/** @brief Creates a wall starting at (x1,y1) and ending at (x2, y2).
	 */
	Wall(int x1, int y1, int x2, int y2);

	/** @brief Returns the direction of this wall.
	 */
	int getDirection();

	/** @brief Detects whether the given point collides with this wall.
	 */
	bool doesCollide(int x, int y);

	virtual void draw();
};

#endif /* _WALL_H */
