/***************************************************************************
 *   Copyright (C) 2009 by Ben Wolf   *
 *   bswolf@cs.cmu.edu   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "calc.h"
#include "debug.h"

int abs(int x) {
	return (x < 0) ? -x : x;
}

double triangleArea(point t1, point t2, point t3) {
	int a = t1.x - t3.x;
	int b = t1.y - t3.y;
	int c = t2.x - t3.x;
	int d = t2.y - t3.y;
	return 0.5 * abs(a * d - b * c);
	// t1.x * t2.y - t3.x * t2.y - t1.x * t3.y + t3.x * t3.y
	//-t1.y * t2.x + t1.y * t3.x + t3.y * t2.x - t3.y * t3.x
	//= x1y2 - x3y2 - x1y3 - x2y1 + x3y1 + x2y3
	// Then times .5,
	// which is the equation on mathworld.
}

bool inTriangle(point x, point t1, point t2, point t3) {
	double a = triangleArea(x, t1, t2);
	double b = triangleArea(x, t1, t3);
	double c = triangleArea(x, t2, t3);
	double d = triangleArea(t1, t2, t3);
	return (a + b + c <= d);
}
