/***************************************************************************
 *   Copyright (C) 2009 by Ben Wolf   *
 *   bswolf@cs.cmu.edu   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _BACKFIRE_DEBUG_H
#define _BACKFIRE_DEBUG_H

#include <iostream>

// Define a set of debugging macros that can easily be turned on and off.

// leave these as they are; remove them from the DEBUG define below
// to turn them off
#define DB_START   0x00000001
#define DB_IMAGE   0x00000002
#define DB_LASER   0x00000004
#define DB_SHIP    0x00000008
#define DB_WALL    0x00000010
#define DB_LEVEL   0x00000020
#define DB_SPRITE  0x00000040
#define DB_LOAD    0x00000080
#define DB_COLLIDE 0x00000100
#define DB_CALC    0x00000200

//master switch - bitwise or of smaller switches
//can also be turned off completely
//#define DEBUG (DB_START | DB_IMAGE | DB_LASER | DB_SHIP | DB_LEVEL\
//				| DB_SPRITE | DB_LOAD | DB_COLLIDE | DB_CALC)

#ifdef DEBUG
	#define db_log(DB_TYPE, msg, ...) { if ((DB_TYPE) & (DEBUG)) \
		printf(msg, ## __VA_ARGS__); }
#else
	#define db_log(DB_TYPE, msg, ...)
#endif

#endif /* _BACKFIRE_DEBUG_H */
