/***************************************************************************
 *   Copyright (C) 2009 by Ben Wolf   *
 *   bswolf@cs.cmu.edu   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "direction.h"

int rotate(int dir, int degrees) {
	return MOD360(dir + degrees);
}

int difference(int dir1, int dir2) {
	int diff = dir2 - dir1;
	if (diff > HALF_CIRCLE) {
		return -CIRC_INVERSE(diff);
	} else if (diff <= -HALF_CIRCLE) {
		return CIRC_INVERSE(-diff);
	} else {
		return diff;
	}
}

int reflect(int dir, int walldir) {
	int normal = walldir;
	int diff = difference(dir, normal);

	return rotate(dir, 2 * diff);
}
