/***************************************************************************
 *   Copyright (C) 2009 by Ben Wolf   *
 *   bswolf@cs.cmu.edu   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _BACKFIRE_GRAPHICS_H
#define _BACKFIRE_GRAPHICS_H

#include "SDL.h"

#define SCREEN_WIDTH 1024
#define SCREEN_HEIGHT 768

enum imgs {
	IMG_BG_SPACE,
	IMG_PLAYER,
	IMG_PLAYER2,
	IMG_PLAYER3,
	IMG_FORWARD_N,
	IMG_FORWARD_E,
	IMG_FORWARD_S,
	IMG_FORWARD_W,
	IMG_DUAL_V,
	IMG_DUAL_H,
	IMG_CRATE,
	IMG_LASER_N,
	IMG_LASER_E,
	IMG_LASER_S,
	IMG_LASER_W,
	IMG_ENEMY_LASER_V,
	IMG_ENEMY_LASER_H,
	IMG_WALL2,
	IMG_WALL_H,
	IMG_WALL_UR,
	IMG_WALL_UL,
	IMG_WALL_V,
	IMG_EXPLOSION,
	IMG_CREDITS,
	IMG_INSTRUCTIONS,
	IMG_MENU,
	IMG_MENU_BOX,
	IMG_BOUNDS_V,
	IMG_BOUNDS_H,
	IMG_LEVEL_WIN,
	IMG_LEVEL_LOSE,
	IMG_SHIP_SELECT,
	IMG_SHIP_SELECT_BAR,
	IMG_GAME_OVER,
	LEN_IMAGES //not an image!!
};

bool InitImages();
void UnloadImages();
SDL_Surface* InitVideo(Uint32 flags);

/** @brief Returns a reference to the desired image.
 *
 *  May return unexpected values if InitImages has not been called
 *  or InitImages failed.
 */
SDL_Surface* GetImage(int image);

void Slock(SDL_Surface *screen);
void Sulock(SDL_Surface *screen);
void DrawPixel(int x, int y,
			unsigned char R, unsigned char G, unsigned char B);
SDL_Surface* LoadImage(const char *imgname);
void DrawImage(SDL_Surface *image, int x, int y);
void DrawPartialImage(SDL_Surface *image, int x, int y, int srcx, int srcy,
				int srcw, int srch);

#endif /* _BACKFIRE_GRAPHICS_H */
